<template>
    <div class="wrapper">
      <el-button type="text" @click="dialogTableVisible = true">打开嵌套表格的 Dialog</el-button>
      <el-dialog
              id="dialog"
              title="收货地址"
                 :width="dialogWidth"
                 :visible.sync="dialogTableVisible"
                 :before-close="handleClose">
        <el-table
          :data="list"
          height="290"
          border
          style="width: 100%">
          <el-table-column
            prop="id"
            label="ID"
            width="80">
          </el-table-column>
          <el-table-column
            prop="name"
            label="姓名"
            width="180">
          </el-table-column>
          <el-table-column
            prop="address"
            label="地址">
          </el-table-column>
        </el-table>
        <el-pagination
          small
          layout="prev, pager, next"
          :page-size="pageSize"
          :total="total"
          @current-change="handlePagin"
        >
        </el-pagination>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="dialogTableVisible = false">确 定</el-button>
        </div>
      </el-dialog>
    </div>
</template>

<script>
export default {
  name: "DialogDemo",
  data () {
    return {
      tableData: [],
      dialogTableVisible: false,
      dialogWidth: '100',
      pageSize: 30, // 每页数据条数
      currentPage: 1 // 当前页码，用于获取展示数据
    }
  },
  mounted() {
    const winWidth = document.body.clientWidth;
    const winHeight = document.body.clientHeight;
    // 弹窗宽度为浏览器窗口宽高最大值的一半
    this.dialogWidth = `${Math.max(winWidth, winHeight) / 2}px`;
    // 循环生成100条数据
    for (let i = 0; i < 100; i++) {
      this.tableData.push(
        {
          id: i,
          name: '王小虎',
          address: `上海市普陀区金沙江路 ${100 + i} 弄`
        }
      )
    }
  },
  computed: {
    total() {
      return this.tableData.length
    },
    // 从生成的数据中根据当前页码截取30条数据
    list() {
      let start = (this.currentPage - 1) * 30 // 页码从1开始，截取数据从0开始，所以要减一
      return this.tableData.slice(start, start + 30)
    }
  },
  methods: {
    // 关闭窗口事件
    handleClose(done) {
      this.$confirm('确认关闭？')
        .then(() => {
          done()
        })
        .catch(() => {})
    },
    // 翻页按钮事件
    handlePagin(p) {
      this.currentPage = p
    }
  }
}
</script>

<style lang="less" scoped>
  /* 重置el-table的数据行高 */
  /deep/ .el-table td {
    padding: 4px 0;
  }
</style>
